// -------------------------------------------------------------------------------
// 
// 		cwCu		ulct@Cf[^\̃wb_
// 
// 				Ver 3.14d
// 
// -------------------------------------------------------------------------------

#ifndef __DXMODELLOADERVMD_H__
#define __DXMODELLOADERVMD_H__

#include "DxCompileConfig.h"

#ifndef DX_NON_MODEL

// CN[h ---------------------------------
#include "DxLib.h"
#include "DxStatic.h"
#include "DxModel.h"
#include "DxModelRead.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` -----------------------------------

// f[^^` ---------------------------------

// VMDL[f[^( 111byte )
struct VMD_KEY
{
	BYTE	Data[ 111 ] ;
/*
	char	Name[ 15 ] ;						// O
	DWORD	Frame ;								// t[
	float	Position[ 3 ] ;						// W
	float	Quaternion[ 4 ] ;					// NH[^jI
	float	PosXBezier[ 4 ] ;					// WwpxWFȐ
	float	PosYBezier[ 4 ] ;					// WxpxWFȐ
	float	PosZBezier[ 4 ] ;					// WypxWFȐ
	float	RotBezier[ 4 ] ;					// ]pxWFȐ
*/
} ;

// VMD\L[f[^( 23byte )
struct VMD_FACE_KEY
{
	BYTE	Data[ 23 ] ;						// f[^
/*
	char	Name[ 15 ] ;						// \
	DWORD	Frame ;								// t[
	float	Factor ;							// uh
*/
} ;

struct VMD_CAMERA_LENGTH
{
	DWORD Count;
};

// VMDJL[f[^
struct VMD_CAMERA 
{
	BYTE	Data[ 61 ] ;						// f[^
/*
	DWORD	FrameNo;							//  4:  0:t[ԍ
	float	Length;								//  8:  4: -()
	float	Location[3];						// 20:  8:ʒu
	float	Rotate[3];							// 32: 20:IC[p // X͕]Ă̂Œ
	BYTE	Interpolation[24];					// 56: 32:ԏ // 炭[6][4]()
	DWORD	ViewingAngle;						// 60: 56:
	BYTE	Perspective;						// 61: 60:ˉeJǂ 0:ˉeJ 1:ˉeJ
*/
};

struct VMD_LIGHT_LENGTH
{
	DWORD Count;
};

struct VMD_LIGHT 
{
	DWORD flameNo;
	DWORD RGB[3];
	DWORD Loc[3];
}; 

// VMDǂ݂ݏpL[\
struct VMD_READ_KEY_INFO
{
	DWORD	Frame ;								// t[
	float	Position[ 3 ] ;						// W
	float	Quaternion[ 4 ] ;					// NH[^jI
	int		Linear[ 4 ] ;						// `ǂ
	float	PosXBezier[ 4 ] ;					// WwpxWFȐ
	float	PosYBezier[ 4 ] ;					// WxpxWFȐ
	float	PosZBezier[ 4 ] ;					// WypxWFȐ
	float	RotBezier[ 4 ] ;					// ]pxWFȐ
	VECTOR	*MVRPosKey ;						// ZoWL[ւ̃|C^
	FLOAT4	*MVRRotKey ;						// Zo]L[ւ̃|C^
	VMD_READ_KEY_INFO *Prev ;					// ÕL[ւ̃AhX
	VMD_READ_KEY_INFO *Next ;					// ̃L[ւ̃AhX
} ;

// VMDǂݍݏpm[h\
struct VMD_READ_NODE_INFO
{
	DWORD				KeyNum ;				// L[̐
	DWORD				MaxFrame ;				// őt[ԍ
	DWORD				MinFrame ;				// ŏt[ԍ
	char				Name[ 16 ] ;			// O
	VMD_READ_KEY_INFO	*FirstKey ;				// L[Xg̐擪
} ;

// VMDǂ݂ݏp\L[\
struct VMD_READ_FACE_KEY_INFO
{
	DWORD	Frame ;								// t[
	float	Factor ;							// uh
	VMD_READ_FACE_KEY_INFO *Prev ;				// ÕL[ւ̃AhX
	VMD_READ_FACE_KEY_INFO *Next ;				// ̃L[ւ̃AhX
} ;

// VMDǂݍݏp\ʏ\
struct VMD_READ_FACE_KEY_SET_INFO
{
	DWORD					KeyNum ;			// L[̐
	DWORD					MaxFrame ;			// őt[ԍ
	DWORD					MinFrame ;			// ŏt[ԍ
	char					Name[ 16 ] ;		// O
	VMD_READ_FACE_KEY_INFO	*FirstKey ;			// L[Xg̐擪
} ;


// VMDǂݍݏpJL[\
struct VMD_READ_CAMERA_KEY_INFO
{
	DWORD	Frame;								//  4:  0:t[ԍ
	float	Length;								//  8:  4: -()
	float	Location[3];						// 20:  8:ʒu
	float	Rotate[3];							// 32: 20:IC[p // X͕]Ă̂Œ
//	BYTE	Interpolation[24];					// 56: 32:ԏ // 炭[6][4]()
	int		Linear[ 6 ] ;						// `ǂ
	float	PosXBezier[ 4 ] ;					// WwpxWFȐ
	float	PosYBezier[ 4 ] ;					// WxpxWFȐ
	float	PosZBezier[ 4 ] ;					// WypxWFȐ
	float	RotBezier[ 4 ] ;					// ]pxWFȐ
	float	LenBezier[ 4 ] ;					// pxWFȐ
	float	ViewAngBezier[ 4 ] ;				// ppxWFȐ
	DWORD	ViewingAngle;						// 60: 56:p
	BYTE	Perspective;						// 61: 60:ˉeJǂ 0:ˉeJ 1:ˉeJ
	VMD_READ_CAMERA_KEY_INFO *Prev ;			// ÕL[ւ̃AhX
	VMD_READ_CAMERA_KEY_INFO *Next ;			// ̃L[ւ̃AhX
} ;

// VMDǂݍݏpJ\
struct VMD_READ_CAMERA_INFO
{
	DWORD						KeyNum ;		// L[̐
	DWORD						MaxFrame ;		// őt[ԍ
	DWORD						MinFrame ;		// ŏt[ԍ
	VMD_READ_CAMERA_KEY_INFO	*FirstKey ;		// L[Xg̐擪
} ;

// VMDǂ݂ݏp\
struct VMD_READ_INFO
{
	DWORD						NodeNum ;			// m[h̐
	VMD_READ_NODE_INFO			*Node ;				// m[hz

	DWORD						FaceKeySetNum ;		// \L[Zbg̐
	VMD_READ_FACE_KEY_SET_INFO	*FaceKeySet ;		// \L[Zbgz

	VMD_READ_KEY_INFO			*KeyBuffer ;		// L[obt@
	VMD_READ_FACE_KEY_INFO		*FaceKeyBuffer ;	// \L[obt@
	VMD_READ_CAMERA_KEY_INFO	*CamKeyBuffer ;		// JL[obt@

	VMD_READ_CAMERA_INFO		*Camera ;			// JL[̏

	DWORD						MaxTime ;			// Aj[V̑
} ;

// ֐錾 -------------------------------------

// ꕔȗs̐ς߂
__inline void MV1LoadModelToVMD_CreateMultiplyMatrix( MATRIX *Out, MATRIX *In1, MATRIX *In2 )
{
	Out->m[0][0] = In1->m[0][0] * In2->m[0][0] + In1->m[0][1] * In2->m[1][0] + In1->m[0][2] * In2->m[2][0] ;
	Out->m[0][1] = In1->m[0][0] * In2->m[0][1] + In1->m[0][1] * In2->m[1][1] + In1->m[0][2] * In2->m[2][1] ;
	Out->m[0][2] = In1->m[0][0] * In2->m[0][2] + In1->m[0][1] * In2->m[1][2] + In1->m[0][2] * In2->m[2][2] ;
	Out->m[0][3] = 0.0f ;

	Out->m[1][0] = In1->m[1][0] * In2->m[0][0] + In1->m[1][1] * In2->m[1][0] + In1->m[1][2] * In2->m[2][0] ;
	Out->m[1][1] = In1->m[1][0] * In2->m[0][1] + In1->m[1][1] * In2->m[1][1] + In1->m[1][2] * In2->m[2][1] ;
	Out->m[1][2] = In1->m[1][0] * In2->m[0][2] + In1->m[1][1] * In2->m[1][2] + In1->m[1][2] * In2->m[2][2] ;
	Out->m[1][3] = 0.0f ;

	Out->m[2][0] = In1->m[2][0] * In2->m[0][0] + In1->m[2][1] * In2->m[1][0] + In1->m[2][2] * In2->m[2][0] ;
	Out->m[2][1] = In1->m[2][0] * In2->m[0][1] + In1->m[2][1] * In2->m[1][1] + In1->m[2][2] * In2->m[2][1] ;
	Out->m[2][2] = In1->m[2][0] * In2->m[0][2] + In1->m[2][1] * In2->m[1][2] + In1->m[2][2] * In2->m[2][2] ;
	Out->m[2][3] = 0.0f ;

	Out->m[3][0] = In1->m[3][0] * In2->m[0][0] + In1->m[3][1] * In2->m[1][0] + In1->m[3][2] * In2->m[2][0] + In2->m[3][0] ;
	Out->m[3][1] = In1->m[3][0] * In2->m[0][1] + In1->m[3][1] * In2->m[1][1] + In1->m[3][2] * In2->m[2][1] + In2->m[3][1] ;
	Out->m[3][2] = In1->m[3][0] * In2->m[0][2] + In1->m[3][1] * In2->m[1][2] + In1->m[3][2] * In2->m[2][2] + In2->m[3][2] ;
	Out->m[3][3] = 1.0f ;
}

// ]̍s̐ς߂( R~RȊO̕ɂ͒lȂ )
__inline void MV1LoadModelToVMD_CreateMultiplyMatrixRotOnly( MATRIX *Out, MATRIX *In1, MATRIX *In2 )
{
	Out->m[0][0] = In1->m[0][0] * In2->m[0][0] + In1->m[0][1] * In2->m[1][0] + In1->m[0][2] * In2->m[2][0] ;
	Out->m[0][1] = In1->m[0][0] * In2->m[0][1] + In1->m[0][1] * In2->m[1][1] + In1->m[0][2] * In2->m[2][1] ;
	Out->m[0][2] = In1->m[0][0] * In2->m[0][2] + In1->m[0][1] * In2->m[1][2] + In1->m[0][2] * In2->m[2][2] ;

	Out->m[1][0] = In1->m[1][0] * In2->m[0][0] + In1->m[1][1] * In2->m[1][0] + In1->m[1][2] * In2->m[2][0] ;
	Out->m[1][1] = In1->m[1][0] * In2->m[0][1] + In1->m[1][1] * In2->m[1][1] + In1->m[1][2] * In2->m[2][1] ;
	Out->m[1][2] = In1->m[1][0] * In2->m[0][2] + In1->m[1][1] * In2->m[1][2] + In1->m[1][2] * In2->m[2][2] ;

	Out->m[2][0] = In1->m[2][0] * In2->m[0][0] + In1->m[2][1] * In2->m[1][0] + In1->m[2][2] * In2->m[2][0] ;
	Out->m[2][1] = In1->m[2][0] * In2->m[0][1] + In1->m[2][1] * In2->m[1][1] + In1->m[2][2] * In2->m[2][1] ;
	Out->m[2][2] = In1->m[2][0] * In2->m[0][2] + In1->m[2][1] * In2->m[1][2] + In1->m[2][2] * In2->m[2][2] ;
}

// 肵ȍWϊvZ
__inline void MV1LoadModelToVMD_VectorTransform( VECTOR &Out, VECTOR &InVec, MATRIX &InMatrix )
{
	Out.x = InVec.x * InMatrix.m[0][0] + InVec.y * InMatrix.m[1][0] + InVec.z * InMatrix.m[2][0] + InMatrix.m[3][0] ;
	Out.y = InVec.x * InMatrix.m[0][1] + InVec.y * InMatrix.m[1][1] + InVec.z * InMatrix.m[2][1] + InMatrix.m[3][1] ;
	Out.z = InVec.x * InMatrix.m[0][2] + InVec.y * InMatrix.m[1][2] + InVec.z * InMatrix.m[2][2] + InMatrix.m[3][2] ;
}

// NH[^jȈZ
__inline FLOAT4 QuatMul( FLOAT4 &q1, FLOAT4 &q2 )
{
	FLOAT4 res ;

	res.x = q1.w * q2.x + q1.x * q2.w + q1.y * q2.z - q1.z * q2.y ;
	res.y = q1.w * q2.y - q1.x * q2.z + q1.y * q2.w + q1.z * q2.x ;
	res.z = q1.w * q2.z + q1.x * q2.y - q1.y * q2.x + q1.z * q2.w ;
	res.w = q1.w * q2.w - q1.x * q2.x - q1.y * q2.y - q1.z * q2.z ;

	return res;
}

// NH[^jIsɕϊ
__inline void QuatConvertToMatrix( MATRIX &mat, FLOAT4 &q, VECTOR &trans )
{
	float sx = q.x * q.x * 2.0f ;
	float sy = q.y * q.y * 2.0f ;
	float sz = q.z * q.z * 2.0f ;
	float cx = q.y * q.z * 2.0f ;
	float cy = q.x * q.z * 2.0f ;
	float cz = q.x * q.y * 2.0f ;
	float wx = q.w * q.x * 2.0f ;
	float wy = q.w * q.y * 2.0f ;
	float wz = q.w * q.z * 2.0f ;

	mat.m[0][0] = 1.0f - ( sy + sz ) ;	mat.m[0][1] = cz + wz ;				mat.m[0][2] = cy - wy ;				mat.m[0][3] = 0.0f ;
	mat.m[1][0] = cz - wz ;				mat.m[1][1] = 1.0f - ( sx + sz ) ;	mat.m[1][2] = cx + wx ;				mat.m[1][3] = 0.0f ;
	mat.m[2][0] = cy + wy ;				mat.m[2][1] = cx - wx ;				mat.m[2][2] = 1.0f - ( sx + sy ) ;	mat.m[2][3] = 0.0f ;
	mat.m[3][0] = trans.x ;				mat.m[3][1] = trans.y ;				mat.m[3][2] = trans.z ;				mat.m[3][3] = 1.0f ;
}

// s񂩂NH[^jIɕϊ
__inline void QuatConvertFromMatrix( FLOAT4 &q, MATRIX &mat )
{
	float s ;
	float tr = mat.m[0][0] + mat.m[1][1] + mat.m[2][2] + 1.0f ;
	if( tr >= 1.0f )
	{
		s = 0.5f / _SQRT( tr ) ;
		q.w = 0.25f / s ;
		q.x = ( mat.m[1][2] - mat.m[2][1] ) * s ;
		q.y = ( mat.m[2][0] - mat.m[0][2] ) * s ;
		q.z = ( mat.m[0][1] - mat.m[1][0] ) * s ;
	}
	else
	{
		float max ;
		max = mat.m[1][1] > mat.m[2][2] ? mat.m[1][1] : mat.m[2][2] ;
		
		if( max < mat.m[0][0] )
		{
			s = _SQRT( mat.m[0][0] - ( mat.m[1][1] + mat.m[2][2] ) + 1.0f ) ;

			float x = s * 0.5f ;
			s = 0.5f / s ;
			q.x = x ;
			q.y = ( mat.m[0][1] + mat.m[1][0] ) * s ;
			q.z = ( mat.m[2][0] + mat.m[0][2] ) * s ;
			q.w = ( mat.m[1][2] - mat.m[2][1] ) * s ;
		}
		else
		if( max == mat.m[1][1] )
		{
			s = _SQRT( mat.m[1][1] - ( mat.m[2][2] + mat.m[0][0]) + 1.0f ) ;

			float y = s * 0.5f ;
			s = 0.5f / s ;
			q.x = ( mat.m[0][1] + mat.m[1][0] ) * s ;
			q.y = y ;
			q.z = ( mat.m[1][2] + mat.m[2][1] ) * s ;
			q.w = ( mat.m[2][0] - mat.m[0][2] ) * s ;
		}
		else
		{
			s = _SQRT( mat.m[2][2] - (mat.m[0][0] + mat.m[1][1]) + 1.0f ) ;

			float z = s * 0.5f ;
			s = 0.5f / s ;
			q.x = ( mat.m[2][0] + mat.m[0][2] ) * s ;
			q.y = ( mat.m[1][2] + mat.m[2][1] ) * s ;
			q.z = z ;
			q.w = ( mat.m[0][1] - mat.m[1][0] ) * s ;
		}
	}
}

__inline static void VmdCalcLine( int &Linear, float &Rate, float &RateH, float &X1, float &X2, float &Y1, float &Y2 )
{
	if( Linear )
	{
		RateH = Rate ;
	}
	else
	{
		int l ;
		float T, InvT ;

		for( l = 0, T = Rate, InvT = 1.0f - T ; l < 32 ; l ++ )
		{
			float TempX = InvT * InvT * T * X1 + InvT * T * T * X2 + T * T * T - Rate ;
			if( TempX < 0.0001f && TempX > -0.0001f ) break ;
			T -= TempX * 0.5f ;
			InvT = 1.0f - T ;
		}
		RateH = InvT * InvT * T * Y1 + InvT * T * T * Y2 + T * T * T ;
	}
}

// NH[^jI̐K
extern void QuaternionNormalize( FLOAT4 *Out, FLOAT4 *Src ) ;

// NH[^jIXYZ]̎擾
extern void QuaternionToEuler( VECTOR *Angle, const FLOAT4 *Qt ) ;

// XYZ]lNH[^jI̍쐬
extern void QuaternionCreateEuler( FLOAT4 *Qt, const VECTOR *Angle ) ;

// 肵ȋtsvZ
extern void MV1LoadModelToVMD_InverseMatrix( MATRIX &InMatrix, MATRIX &OutMatrix ) ;

// ulct@C̊{ǂݍ( -1:G[ )
extern int LoadVMDBaseData( VMD_READ_INFO *VmdData, void *DataBuffer, int DataSize ) ;

// ulct@C̊{̌n
extern int TerminateVMDBaseData( VMD_READ_INFO *VmdData ) ;

// J̃Aj[Vǂݍ݂悤f[^ɒǉ
extern int SetupVMDCameraAnim( VMD_READ_INFO *VmdData, MV1_MODEL_R *RModel, const wchar_t *Name, MV1_ANIMSET_R *AnimSet ) ;

// VMDt@CoCiɓǂݍ
extern int LoadFile_VMD(
	void **					VmdData,
	int *					FileSize,
	int						FileNumber,
	MV1_FILE_READ_FUNC *	FileReadFunc,
	const wchar_t *			Name,
	int						NameLen,
	const wchar_t *			CurrentDir,
	int *					LoopMotionFlag,
	float *					BaseGravity,
	int *					GravityNo,
	int *					GravityEnable,
	VECTOR *				Gravity
) ;


#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif

#endif
